#include <Windows.h>
#include <CommCtrl.h>
#include "Hook.h"
#include "EditMem.h"

bool running = true;

HWND hMain(nullptr),
	 hSC(nullptr),
	 hText(nullptr);

void ZeroTimer();

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASSEX wcMainWin = { };

	wcMainWin.cbSize		= sizeof(WNDCLASSEX);
    wcMainWin.lpfnWndProc	= WndProc;
    wcMainWin.hInstance		= hInstance;
    wcMainWin.hIcon			= NULL;
	wcMainWin.hIconSm		= NULL;
    wcMainWin.hCursor		= LoadCursor(NULL, IDC_ARROW);
    wcMainWin.hbrBackground	= (HBRUSH) (COLOR_APPWORKSPACE + 1);
	wcMainWin.lpszMenuName	= NULL; // MAKEINTRESOURCE(IDR_MENU1);
    wcMainWin.lpszClassName	= "MainWin";

	if ( !RegisterClassEx(&wcMainWin) )
		return 0;

	hMain = CreateWindowExA(NULL, "MainWin", "No Timer",
		WS_MINIMIZEBOX|WS_SYSMENU,
		CW_USEDEFAULT, CW_USEDEFAULT, 186, 125,
		NULL, NULL, hInstance, NULL);

	if ( !hMain )
		return 0;

	InitCommonControls();
	ShowWindow(hMain, SW_SHOW);
	UpdateWindow(hMain);

	MSG msg;
	while ( running )
	{
		if ( PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) )
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

		ZeroTimer();
		Sleep(1); // No need to consume a core
	}
	return msg.wParam;
}

void ZeroTimer()
{
	if ( SCsOpen(hSC) )
	{
		UINT countdown = 0;
		if ( ReadMem(0x0066FBFC, countdown) ) // Read countdown timer
		{
			if ( countdown > 0 )
				WriteMem(0x0066FBFC, 1); // Set timer to ~0
		}
	}
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch ( msg )
	{
		case WM_SIZE:
			{
				RECT rcMain;
				GetClientRect(hMain, &rcMain);
				int width = rcMain.right-rcMain.left,
					height = rcMain.bottom-rcMain.top;
				SetWindowPos(hText, NULL, rcMain.left, rcMain.top, width, height, SWP_NOZORDER);
			}
			break;

		case WM_CREATE:
			hText = CreateWindow("STATIC", "Brood War not detected.", WS_CHILD|SS_CENTER|SS_CENTERIMAGE,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				hWnd, NULL, GetModuleHandle(NULL), NULL);
			ShowWindow(hText, SW_SHOW);
			break;

		case WM_DESTROY:
			running = false;
			PostQuitMessage(0);
			break;

		default:
			return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}